diff --git a/src/main/java/net/minecraft/server/net/command/commands/DeopCommand.java b/src/main/java/net/minecraft/server/net/command/commands/DeopCommand.java
new file mode 100644
index 000000000..6b0436b5e
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/DeopCommand.java
@@ -0,0 +1,55 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+import java.util.List;
+
+public class DeopCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("commands.commander.deop.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("deop")
+            .requires(CommandSource::hasAdmin)
+            .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.players())
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    if (!(source instanceof IServerCommandSource))
+                        throw CommandExceptions.multiplayerWorldOnly().create();
+
+                    EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                    List<? extends Entity> entities = entitySelector.get(source);
+                    MinecraftServer server = ((IServerCommandSource) source).getServer();
+
+                    boolean deoppedSomeone = false;
+
+                    for (Entity entity : entities) {
+                        ServerPlayer player = (ServerPlayer) entity;
+                        if (player.isOperator()) {
+                            deoppedSomeone = true;
+                            server.playerList.deopPlayer(player.uuid);
+                            source.sendTranslatableMessage("commands.commander.deop.success", player.username);
+                            source.sendTranslatableMessage(player, "commands.commander.deop.success_receiver");
+                        }
+                        server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                    }
+                    if (!deoppedSomeone) {
+                        throw FAILURE.create();
+                    }
+                    return Command.SINGLE_SUCCESS;
+                })));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java b/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java
new file mode 100644
index 000000000..14de55a97
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/DifficultyCommand.java
@@ -0,0 +1,78 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+
+import java.util.Arrays;
+import java.util.List;
+
+public class DifficultyCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("difficulty")
+                .requires(CommandSource::hasAdmin)
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    switch (source.getWorld().getDifficulty()) {
+                        case PEACEFUL:
+                            source.sendTranslatableMessage("commands.commander.difficulty.query.success", I18n.getInstance().translateKey("options.difficulty.peaceful"));
+                            break;
+                        case EASY:
+                            source.sendTranslatableMessage("commands.commander.difficulty.query.success", I18n.getInstance().translateKey("options.difficulty.easy"));
+                            break;
+                        case NORMAL:
+                            source.sendTranslatableMessage("commands.commander.difficulty.query.success", I18n.getInstance().translateKey("options.difficulty.normal"));
+                            break;
+                        case HARD:
+                            source.sendTranslatableMessage("commands.commander.difficulty.query.success", I18n.getInstance().translateKey("options.difficulty.hard"));
+                            break;
+                        default:
+                            source.sendTranslatableMessage("commands.commander.difficulty.query.success_unknown");
+                            break;
+                    }
+                    return Command.SINGLE_SUCCESS;
+                })
+                .then(LiteralArgumentBuilder.<CommandSource>literal("peaceful")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            return setDifficulty(source, 0);
+                        }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("easy")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            return setDifficulty(source, 1);
+                        }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("normal")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            return setDifficulty(source, 2);
+                        }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("hard")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            return setDifficulty(source, 3);
+                        })));
+    }
+
+    private static final List<String> difficultyStrings = Arrays.asList("peaceful", "easy", "normal", "hard");
+
+    private static int setDifficulty(CommandSource source, int difficulty) throws CommandSyntaxException {
+        if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
+
+        MinecraftServer server = ((IServerCommandSource)source).getServer();
+
+        for (World world : server.dimensionWorlds) {
+            world.setDifficulty(difficulty, true);
+        }
+        server.difficulty = difficulty;
+        source.sendTranslatableMessage("commands.commander.difficulty.set.success", I18n.getInstance().translateKey("options.difficulty." + difficultyStrings.get(difficulty)));
+        return Command.SINGLE_SUCCESS;
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/EmotesCommand.java b/src/main/java/net/minecraft/server/net/command/commands/EmotesCommand.java
new file mode 100644
index 000000000..148f5182c
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/EmotesCommand.java
@@ -0,0 +1,26 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.core.net.ChatEmotes;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.command.CommandSource;
+
+import java.util.ArrayList;
+import java.util.Map;
+
+public class EmotesCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("emotes")
+            .executes(c -> {
+                CommandSource source = c.getSource();
+                source.sendTranslatableMessage("commands.commander.emotes.success");
+                ArrayList<Map.Entry<String, Character>> entryList = new ArrayList<Map.Entry<String, Character>>(ChatEmotes.getEmotes().entrySet());
+                entryList.sort(Map.Entry.comparingByKey());
+                for (Map.Entry<String, Character> entry : entryList) {
+                    source.sendMessage(":" + TextFormatting.CYAN + entry.getKey().substring(1, entry.getKey().length() - 1) + TextFormatting.RESET + ":" + " -> " + entry.getValue());
+                }
+                return entryList.size();
+            }));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/ListCommand.java b/src/main/java/net/minecraft/server/net/command/commands/ListCommand.java
new file mode 100644
index 000000000..81fffcc7c
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/ListCommand.java
@@ -0,0 +1,47 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+
+public class ListCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("commands.commander.list.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("list")
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
+
+                    MinecraftServer server = ((IServerCommandSource)source).getServer();
+
+                    int playerCount = server.playerList.playerEntities.size();
+                    if (playerCount < 100) {
+                        if (playerCount == 0) throw FAILURE.create();
+                        StringBuilder builder = new StringBuilder();
+                        for (int i = 0; i < server.playerList.playerEntities.size(); ++i) {
+                            if (i > 0) {
+                                builder.append(", ");
+                            }
+                            builder.append(CommandHelper.getEntityName(server.playerList.playerEntities.get(i)));
+                        }
+                        if (playerCount == 1) {
+                            source.sendTranslatableMessage("commands.commander.list.success_single", playerCount, builder.toString());
+                        } else {
+                            source.sendTranslatableMessage("commands.commander.list.success_multiple", playerCount, builder.toString());
+                        }
+                    } else {
+                        source.sendTranslatableMessage("commands.commander.list.success_too_long", playerCount);
+                    }
+
+                    return Command.SINGLE_SUCCESS;
+                }));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/MeCommand.java b/src/main/java/net/minecraft/server/net/command/commands/MeCommand.java
new file mode 100644
index 000000000..fc1cddca8
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/MeCommand.java
@@ -0,0 +1,40 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.BoolArgumentType;
+import com.mojang.brigadier.arguments.StringArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.packet.ChatPacket;
+
+public class MeCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("me")
+            .then(RequiredArgumentBuilder.<CommandSource, Boolean>argument("asterisk", BoolArgumentType.bool())
+                .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        String message = StringArgumentType.getString(c, "message");
+                        boolean asterisk = BoolArgumentType.getBool(c, "asterisk");
+                        if (!(source instanceof IServerCommandSource))
+                            throw CommandExceptions.multiplayerWorldOnly().create();
+                        String senderName = source.getName();
+                        ((IServerCommandSource) source).getServer().playerList.sendPacketToAllPlayers(new ChatPacket((asterisk ? "* " : "") + senderName + message));
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    String message = StringArgumentType.getString(c, "message");
+                    if (!(source instanceof IServerCommandSource))
+                        throw CommandExceptions.multiplayerWorldOnly().create();
+                    String senderName = source.getName();
+                    ((IServerCommandSource) source).getServer().playerList.sendPacketToAllPlayers(new ChatPacket("* " + senderName + message));
+                    return Command.SINGLE_SUCCESS;
+                })));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/NicknameCommand.java b/src/main/java/net/minecraft/server/net/command/commands/NicknameCommand.java
new file mode 100644
index 000000000..f828b62c0
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/NicknameCommand.java
@@ -0,0 +1,121 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.StringArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+import java.util.List;
+
+public class NicknameCommand {
+    private static final SimpleCommandExceptionType NICKNAME_TOO_LARGE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("commands.commander.nickname.exception_too_large"));
+    private static final SimpleCommandExceptionType NICKNAME_TOO_SMALL = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("commands.commander.nickname.exception_too_small"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("nickname")
+            .then(LiteralArgumentBuilder.<CommandSource>literal("set")
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.player())
+                    .requires(CommandSource::hasAdmin)
+                    .then(RequiredArgumentBuilder.<CommandSource, String>argument("nickname", StringArgumentType.greedyString())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            String nickname = c.getArgument("nickname", String.class);
+                            if (nickname.length() > 16) throw NICKNAME_TOO_LARGE.create();
+                            if (nickname.isEmpty()) throw NICKNAME_TOO_SMALL.create();
+                            List<? extends Entity> entities = entitySelector.get(source);
+
+                            ServerPlayer player = (ServerPlayer) entities.get(0);
+
+                            player.nickname = nickname;
+                            player.hadNicknameSet = true;
+                            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                            if (source.getSender() == player) {
+                                source.sendTranslatableMessage("commands.commander.nickname.set.success", nickname);
+                            } else {
+                                source.sendTranslatableMessage("commands.commander.nickname.set.success_other", player.username, nickname);
+                                source.sendTranslatableMessage(player, "commands.commander.nickname.set.success_receiver", nickname);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        })))
+                .then(RequiredArgumentBuilder.<CommandSource, String>argument("nickname", StringArgumentType.greedyString())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        String nickname = c.getArgument("nickname", String.class);
+                        if (nickname.length() > 16) throw NICKNAME_TOO_LARGE.create();
+                        if (nickname.isEmpty()) throw NICKNAME_TOO_SMALL.create();
+
+                        ServerPlayer player = (ServerPlayer) source.getSender();
+
+                        if (player == null) throw CommandExceptions.notInWorld().create();
+
+                        player.nickname = nickname;
+                        player.hadNicknameSet = true;
+                        player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+
+                        source.sendTranslatableMessage("commands.commander.nickname.set.success", nickname);
+
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then(LiteralArgumentBuilder.<CommandSource>literal("get")
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.player())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                        List<? extends Entity> entities = entitySelector.get(source);
+                        ServerPlayer player = (ServerPlayer) entities.get(0);
+
+                        source.sendTranslatableMessage("commands.commander.nickname.get.success", player.username, player.nickname);
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then(LiteralArgumentBuilder.<CommandSource>literal("reset")
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.player())
+                    .requires(CommandSource::hasAdmin)
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                        List<? extends Entity> entities = entitySelector.get(source);
+
+                        ServerPlayer player = (ServerPlayer) entities.get(0);
+
+                        player.nickname = "";
+                        player.hadNicknameSet = false;
+                        player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                        if (source.getSender() == player) {
+                            source.sendTranslatableMessage("commands.commander.nickname.reset.success");
+                        } else {
+                            source.sendTranslatableMessage("commands.commander.nickname.reset.success_other", player.username);
+                            source.sendTranslatableMessage(player, "commands.commander.nickname.reset.success_receiver");
+                        }
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+
+                    ServerPlayer player = (ServerPlayer) source.getSender();
+
+                    if (player == null) throw CommandExceptions.notInWorld().create();
+
+                    player.nickname = "";
+                    player.hadNicknameSet = false;
+                    player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+
+                    source.sendTranslatableMessage("commands.commander.nickname.reset.success", player.username);
+
+                    return Command.SINGLE_SUCCESS;
+                })));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("nick")
+            .redirect(command));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/OpCommand.java b/src/main/java/net/minecraft/server/net/command/commands/OpCommand.java
new file mode 100644
index 000000000..26f73684b
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/OpCommand.java
@@ -0,0 +1,55 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+import java.util.List;
+
+public class OpCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("commands.commander.op.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("op")
+            .requires(CommandSource::hasAdmin)
+            .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.players())
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    if (!(source instanceof IServerCommandSource))
+                        throw CommandExceptions.multiplayerWorldOnly().create();
+
+                    EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                    List<? extends Entity> entities = entitySelector.get(source);
+                    MinecraftServer server = ((IServerCommandSource) source).getServer();
+
+                    boolean oppedSomeone = false;
+
+                    for (Entity entity : entities) {
+                        ServerPlayer player = (ServerPlayer) entity;
+                        if (!player.isOperator()) {
+                            oppedSomeone = true;
+                            server.playerList.opPlayer(player.uuid);
+                            source.sendTranslatableMessage("commands.commander.op.success", player.username);
+                            source.sendTranslatableMessage(player, "commands.commander.op.success_receiver");
+                        }
+                        server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                    }
+                    if (!oppedSomeone) {
+                        throw FAILURE.create();
+                    }
+                    return Command.SINGLE_SUCCESS;
+                })));
+    }
+}
